#include <math.h>
#include <iostream>
#include <fstream>
using namespace std;

const int ROWS = 10;
const int COLS = 10;
const int MAXL = 50;
const int NERO = 0;
const int BIANCO = 100;

struct Immagine {
	int data[ROWS][COLS];
	char titolo[MAXL];
};


bool leggi(Immagine* m, char nf[]) ;
int medio(Immagine* m, int r, int c) ;
void luminoso(const Immagine* m, int* pr, int* pc) ;
void trasforma(Immagine* m, int soglia) ;
void stampa(const Immagine* m) ;

int main(){
	Immagine im1;
	cout << "Contenuto del file im1.dat:";
	system("type im1.dat"); // stampa a video il contenuto del file
	if(leggi(&im1, "im1.dat")) cout << "Immagine 1 caricata correttamente" << endl;
	else cout << "Problemi durante la lettura" << endl;
	system("pause");

	cout << "Provo a stampare l'immagine 1:" << endl;
	stampa(&im1);
	system("pause");

	Immagine im2;
	cout << "Contenuto del file im2.dat:";
	system("type im2.dat"); // stampa a video il contenuto del file
	if(leggi(&im2, "im2.dat")) cout << "Immagine 2 caricata correttamente" << endl;
	else cout << "Problemi durante la lettura" << endl;
	system("pause");

	cout << "Provo a stampare l'immagine 2:" << endl;
	stampa(&im2);
	system("pause");

	cout << "Chiamo la funzione luminoso (immagine 1):" << endl;
	int x, y;
	luminoso(&im1, &x, &y);
	cout << "Il punto piu' luminoso ha coordinate (" << x << ", " << y << ")" << endl;

	cout << "Chiamo la funzione trasforma e ristampo l'immagine 1" << endl;
	trasforma(&im1, 5);	
	stampa(&im1);
	system("pause");

	cout << "Chiamo la funzione trasforma e ristampo l'immagine 2" << endl;
	trasforma(&im2, 5);	
	stampa(&im2);
	system("pause");

	cout << "Chiamo la funzione medio (immagine 2)" << endl;
	int mmm = medio(&im2, 1, 1);
	cout << "Valore ottenuto: " << mmm << endl;
	cout << "Ristampo l'immagine" << endl;	
	stampa(&im2);
	system("pause");
	cout << "Chiamo la funzione medio (immagine 2)" << endl;
	mmm = medio(&im2, 9, 9);
	cout << "Valore ottenuto: " << mmm << endl;
	cout << "Ristampo l'immagine" << endl;	
	stampa(&im2);
	system("pause");

	return 0;
}
